/***************************************************************************
                          kimap.cpp  -  description
                             -------------------
    begin                : Sun Dec 19 15:50:22 MET 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "extern.h"
#include "resource.h"
#include "kimap.h"
#include "kmaddrbookdlg.h"
#include "kmcomposewin.h"
#include "kmsettings.h"
#include "kimapview.h"
#include "kbusyptr.h"
#include "kmaddrbook.h"
#include "kpasswdconfig.h"
#include "nmmailview.h"
//#include "nmselect.h"
#include "nmlistfolders.h"
#include "nmfoldercontent.h"
#include "nmdocking.h"
#include "nmstatusbar.h"
#include <qprinter.h>
#include <qwidget.h>
//#include <qprogressbar.h>
#include <kaccel.h>
#include <kiconloader.h>
#include <kwm.h>
#include "nmglobalfolders.h"
#undef Status

KImap::KImap(const char *box) : KTMainWindow()
{
	docked = false;
	file_menu = NULL;
	help_menu = NULL;
	config=kapp->getConfig();
	
  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts

	if(!kbp) kbp = new KBusyPtr();
//	my_client = new NMClient();
	if(!dock) dock = new DockWidget();
	dock->dock();
	config->setGroup("Identity");
	if(!passwd) passwd = new KPasswdConfig( app->localkdedir() + "/share/apps/kimap/passwords",config->readEntry("PGP Default Key"));
  initStatusBar();
  initMenuBar();
  initView(box);
	initMenuBar();
  initToolBar();
  initKeyAccel();
	
  readOptions();

  ///////////////////////////////////////////////////////////////////
  // disable menu and toolbar items at startup
	if(box && *box) {
		disableCommand(ID_FOLDER_NEW);
		disableCommand(ID_FOLDER_EXPUNGE);
		disableCommand(ID_FOLDER_STATUS);
		disableCommand(ID_FOLDER_CHECK);
	}

//  disableCommand(ID_FILE_SAVE);
//  disableCommand(ID_FILE_PRINT);
}

KImap::~KImap()
{
//	checkForQueuedMsg();
	mStatusBar = NULL;
	kimap = NULL;
	if(gFolders) gFolders->writeFolders(kapp);
}

void KImap::readConfig()
{
	if(view) view->readConfig();
}

void KImap::writeConfig(bool withSync)
{
	if(view) view->writeConfig(withSync);
}


//signal to build the menu of available folders
//-----------------------------------------------------------------------------
void KImap::slotMakeMenu(QPopupMenu *menu,const QObject *obj,const char *recv)
{
	emit signalMakeMenu(menu,obj,recv);
}

//signal to get the actual specification for a folder
//-----------------------------------------------------------------------------
void KImap::slotMenuText(int id,char **txtptr)
{
	emit signalMenuText(id,txtptr);
}

//open the addressbook
//-----------------------------------------------------------------------------
void KImap::slotAddrBook()
{
  KMAddrBookEditDlg dlg(addrBook);
  dlg.exec();
}

//open a new composer
//-----------------------------------------------------------------------------
void KImap::slotCompose()
{
	KMComposeWin *composer=new KMComposeWin(NULL);
	composer->show();
}

//open the preferences dialog
//-----------------------------------------------------------------------------
void KImap::slotPreferences()
{
		KMSettings *setting = new KMSettings;
		setting->exec();
		delete setting;
}

//signal to perform a move after the selection from the folders menu
//-----------------------------------------------------------------------------
void KImap::slotMoveFolder(int id)
{
	emit signalMMove(id);
}

//signal to perform a move after the selection from the group menu
//-----------------------------------------------------------------------------
void KImap::slotGroupMoveFolder(int id)
{
	emit signalGroupMoveFolder(id);
}

void KImap::commandCallback(int id_){
  switch (id_){
    case ID_FILE_SAVE_FILE:
    	emit signalMMove(-1);
    	break;
    case ID_FILE_COMPOSE:
    	slotCompose();
    	break;
    case ID_FILE_ADDRESSBOOK:
    	slotAddrBook();
    	break;
    case ID_FILE_SENDQUEUED:
    	emit signalSendQueuedMessages();
    	break;
    case ID_FILE_PREFERENCES:
    	slotPreferences();
    	break;
    case ID_FILE_PRINT:
//    	checkForQueuedMsg();
    	slotFilePrint();
    	break;
    case ID_FILE_QUIT:
    	slotFileQuit();
    	break;

		case ID_FOLDER_NEW:
			slotFolderNew();
			break;
		case ID_FOLDER_EXPUNGE:
			slotFolderExpunge();
			break;
		case ID_FOLDER_STATUS:
			if(gFolders) gFolders->slotStatusLookup(true);
			break;
		case ID_FOLDER_CHECK:
			if(gFolders) gFolders->slotStatusLookup(false);
			break;


/*		case ID_MESSAGE_NEXT:
			emit signalMessageNext();
			break;
		case ID_MESSAGE_NEXTUNREAD:
			emit signalMessageNextUnread();
			break;
		case ID_MESSAGE_PREV:
			emit signalMessagePrev();
			break;
		case ID_MESSAGE_PREVUNREAD:
			emit signalMessagePrevUnread();
			break;
		case ID_MESSAGE_REPLY:
			emit signalMessageReply();
			break;
		case ID_MESSAGE_REPLYALL:
			emit signalMessageReplyAll();
			break;
		case ID_MESSAGE_FORWARDINLINE:
			emit signalMessageForwardInline();
			break;
		case ID_MESSAGE_FORWARDATTACHED:
			emit signalMessageForwardAttached();
			break;
		case ID_MESSAGE_DELETE:
			emit signalMessageDelete();
			break;
		case ID_MESSAGE_FLAG:
			emit signalMessageFlag();
			break;
		case ID_MESSAGE_SEEN:
			emit signalMessageSeen();
			break;
		case ID_MESSAGE_ANSWER:
			emit signalMessageAnswer();
			break;
		case ID_MESSAGE_MOVEFOLDER:
			emit signalMessageMoveFolder();
			break; */

/*		case ID_GROUP_CREATE:
			emit signalGroupCreate();
			break;
		case ID_GROUP_CLEAR:
			emit signalGroupClear();
			break;
		case ID_GROUP_DELETE:
			emit signalGroupDelete();
			break;
		case ID_GROUP_UNDELETE:
			emit signalGroupUndelete();
			break;
		case ID_GROUP_PRINT:
			emit signalGroupPrint();
			break;
		case ID_GROUP_MOVEFOLDER:
			//handled by the submenus
			break; */

/*    case ID_VIEW_TOOLBAR:
    	slotViewToolBar();
    	break;
    case ID_VIEW_STATUSBAR:
    	slotViewStatusBar();
    	break;
    default:
		  switch (10 * (int)(id_ / 10)){
				case ID_VIEW_HEADER: */
/*				  view_menu->setItemChecked((int)view->mailview->headerStyle() + ID_VIEW_HEADER, FALSE);
					view->mailview->setHeaderStyle((enum NMMailView::HeaderStyle)(id_ % 10));
				  view_menu->setItemChecked((int)view->mailview->headerStyle() + ID_VIEW_HEADER, TRUE);
				break;
				case ID_VIEW_ATTACHM:
				  view_menu->setItemChecked((int)view->mailview->attachmentStyle()+ ID_VIEW_ATTACHM, FALSE);
					view->mailview->setAttachmentStyle((enum NMMailView::AttachmentStyle)(id_ % 10));
				  view_menu->setItemChecked((int)view->mailview->attachmentStyle()+ ID_VIEW_ATTACHM, TRUE);
				break;
				default:
				break;
			}
    	break; */
  }
}

void KImap::statusCallback(int id_){
  switch (id_){
    case ID_FILE_PRINT:
    	slotStatusHelpMsg(i18n("Prints the current document"));
    	break;
    case ID_FILE_QUIT:{
    	QString caption=kapp->getCaption();
    	slotStatusHelpMsg(i18n("Exits "+ caption));
    	break;
    }

		case ID_GROUP_MOVEFOLDER:
			emit signalMakeMenu( group_folder_menu ,this,SLOT(slotGroupMoveFolder(int)));
			break;

		case ID_MESSAGE_MOVEFOLDER:
			emit signalMakeMenu( move_folder_menu ,this,SLOT(slotMoveFolder(int)));
			break;

    case ID_VIEW_TOOLBAR:
    	slotStatusHelpMsg(i18n("Enables / disables the actual Toolbar"));
    	break;
    case ID_VIEW_STATUSBAR:
    	slotStatusHelpMsg(i18n("Enables / disables the actual Statusbar"));
    	break;
		default:
			break;
  }
}

void KImap::slotFolderNew()
{
	if(gFolders) gFolders->slotNewFolder("");
}

void KImap::slotFilePrint()
{
  slotStatusMsg(i18n("Printing..."));

  QPrinter printer;
  if (printer.setup(this)){
			view->print(&printer);
	}

  slotStatusMsg(i18n("Ready."));
}

void KImap::slotFileQuit()
{
	saveOptions();
	// close the first window, the list makes the next one the first again.
	// This ensures that queryClose() is called on each window to ask for closing
	KTMainWindow* w;
	if(memberList){
		for(w=memberList->first(); w; w=memberList->first()){
			// only close the window if the closeEvent is accepted. If the user presses Cancel on the saveModified() dialog,
			// the window and the application stay open.
			if(!w->close())
				break;
		}
	}	
}

void KImap::slotFolderExpunge()
{
//	if(view && view->overview) view->overview->slotFolderExpunge();
}

/* void KImap::slotViewToolBar()
{
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
	if( view_menu->isItemChecked(ID_VIEW_TOOLBAR))
	  view_menu->setItemChecked(ID_VIEW_TOOLBAR, false);
	else
		view_menu->setItemChecked(ID_VIEW_TOOLBAR, true);
		
  enableToolBar();

  slotStatusMsg(i18n("Ready."));
} */

/*void KImap::slotViewStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
	if( view_menu->isItemChecked(ID_VIEW_STATUSBAR))
	  view_menu->setItemChecked(ID_VIEW_STATUSBAR, false);
	else
		view_menu->setItemChecked(ID_VIEW_STATUSBAR, true);

  enableStatusBar();

  slotStatusMsg(i18n("Ready."));
} */


void KImap::slotStatusMsg(const char *text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
	if(mStatusBar) {
	  mStatusBar->clear();
	  mStatusBar->changeItem(text, ID_STATUS_MSG );
	}
	kapp->processEvents(1);
}


void KImap::slotStatusHelpMsg(const char *text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  if(mStatusBar) mStatusBar->message(text, 2000);
}

void KImap::saveOptions()
{	
	config->setGroup("General Options");
	config->writeEntry("Geometry", size() );
  config->writeEntry("Show Toolbar", toolBar()->isVisible());
  if(mStatusBar) config->writeEntry("Show Statusbar",mStatusBar->isVisible());
  config->writeEntry("MenuBarPos", (int)menuBar()->menuBarPos());
  config->writeEntry("ToolBarPos",  (int)toolBar()->barPos());
}


void KImap::readOptions()
{
	
	config->setGroup("General Options");

	// bar status settings
	bool bViewToolbar = config->readBoolEntry("Show Toolbar", true);
//	view_menu->setItemChecked(ID_VIEW_TOOLBAR, bViewToolbar);
	if(!bViewToolbar)
		enableToolBar(KToolBar::Hide);
	
  bool bViewStatusbar = config->readBoolEntry("Show Statusbar", true);
//	view_menu->setItemChecked(ID_VIEW_STATUSBAR, bViewStatusbar);
	if(!bViewStatusbar)
		enableStatusBar(KStatusBar::Hide);
	
	// bar position settings
	KMenuBar::menuPosition menu_bar_pos;
	menu_bar_pos=(KMenuBar::menuPosition)config->readNumEntry("MenuBarPos", KMenuBar::Top);

  KToolBar::BarPosition tool_bar_pos;
  tool_bar_pos=(KToolBar::BarPosition)config->readNumEntry("ToolBarPos", KToolBar::Top);

	menuBar()->setMenuBarPos(menu_bar_pos);
  toolBar()->setBarPos(tool_bar_pos);
	
  QSize size=config->readSizeEntry("Geometry");
	if(!size.isEmpty())
		resize(size);
}

void KImap::saveProperties(KConfig* )
{
}


void KImap::readProperties(KConfig*)
{
	QString filename = config->readEntry("filename","");
  QString caption=kapp->getCaption();	
  setCaption(caption);
}		

void KImap::initView(const char *box)
{ 
  ////////////////////////////////////////////////////////////////////
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  view = new KImapView(this,box);
  setView(view);
  QString caption=kapp->getCaption();
  if(box && *box)
  {
		caption.sprintf("%s : %s",kapp->getCaption(),box);
  }
  setCaption(caption);

}

void KImap::enableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // enable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,true);
  toolBar()->setItemEnabled(id_,true);
}

void KImap::disableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // disable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,false);
  toolBar()->setItemEnabled(id_,false);
}

void KImap::initKeyAccel()
{
	key_accel = new KAccel( this );
	
	// file_menu accelerators
	key_accel->connectItem( KAccel::New, this, SLOT( slotFolderNew() ) );

	key_accel->insertItem( "scrollFldDown","scrollFldDown","CTRL+Down");
	key_accel->connectItem( "scrollFldDown", view, SLOT( slotFolderDown() ) );

	key_accel->insertItem( "scrollFldUp","scrollFldUp","CTRL+Up");
	key_accel->connectItem( "scrollFldUp", view, SLOT( slotFolderUp() ) );

	key_accel->insertItem( "expandFld","expandFld","CTRL+Right");
	key_accel->connectItem( "expandFld", view, SLOT( slotFolderExpand() ) );

	key_accel->insertItem( "collapseFld","collapseFld","CTRL+Left");
	key_accel->connectItem( "collapseFld", view, SLOT( slotFolderCollapse() ) );

	key_accel->insertItem( "scrollMsgDown","scrollMsgDown","ALT+Down");
	key_accel->connectItem( "scrollMsgDown", view, SLOT( slotMessageDown() ) );

	key_accel->insertItem( "scrollMsgUp","scrollMsgUp","ALT+Up");
	key_accel->connectItem( "scrollMsgUp", view, SLOT( slotMessageUp() ) );

	key_accel->insertItem( "expandMsg","expandMsg","ALT+Right");
	key_accel->connectItem( "expandMsg", view, SLOT( slotMessageExpand() ) );

	key_accel->insertItem( "collapseMsg","collapseMsg","ALT+Left");
	key_accel->connectItem( "collapseMsg", view, SLOT( slotMessageCollapse() ) );

//	key_accel->connectItem( KAccel::Save, this, SLOT( slotFileSave() ) );
//	key_accel->connectItem( KAccel::Close, this, SLOT( slotFileClose() ) );
	key_accel->connectItem( KAccel::Print, this, SLOT( slotFilePrint() ) );
	key_accel->connectItem( KAccel::Quit, this, SLOT( slotFileQuit() ) );
	// edit_menu accelerators
/*	key_accel->connectItem( KAccel::Cut, this, SLOT( slotEditCut() ) );
	key_accel->connectItem( KAccel::Copy, this, SLOT( slotEditCopy() ) );
	key_accel->connectItem( KAccel::Paste, this, SLOT( slotEditPaste() ) ); */

	key_accel->connectItem( KAccel::Help, kapp, SLOT( appHelpActivated() ) );
			
//	key_accel->changeMenuAccel(	file_menu, ID_FILE_COMPOSE, KAccel::New );
	key_accel->changeMenuAccel(	file_menu, ID_FILE_COMPOSE, KAccel::New );
//	key_accel->changeMenuAccel(	file_menu, ID_FILE_OPEN, KAccel::Open );
	key_accel->changeMenuAccel(	file_menu, ID_FILE_SAVE_FILE, KAccel::Save );
//	key_accel->changeMenuAccel( file_menu, ID_FILE_CLOSE, KAccel::Close );
	key_accel->changeMenuAccel(	file_menu, ID_FILE_PRINT, KAccel::Print );
	key_accel->changeMenuAccel(	file_menu, ID_FILE_QUIT, KAccel::Quit );

  key_accel->readSettings();	
}

void KImap::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry file_menu
if(! file_menu)
{
  file_menu = new QPopupMenu();

  file_menu->insertItem(Icon("filenew.xpm"), i18n("&New Message"), ID_FILE_COMPOSE );
  file_menu->insertSeparator();
//  file_menu->insertItem(Icon("filefloppy.xpm") ,i18n("&Save to File"), ID_FILE_SAVE_FILE );
//  file_menu->insertSeparator();
//  file_menu->insertItem(Icon("fileprint.xpm"), i18n("&Print..."), ID_FILE_PRINT );
  file_menu->insertItem(i18n("P&references"), ID_FILE_PREFERENCES );
  file_menu->insertItem(Icon("openbook.xpm"), i18n("&Addressbook"), ID_FILE_ADDRESSBOOK );
  file_menu->insertItem(i18n("&Send queued Messages"), ID_FILE_SENDQUEUED );
  file_menu->insertSeparator();
  file_menu->insertItem(i18n("E&xit"), ID_FILE_QUIT );

  menuBar()->insertItem(i18n("&File"), file_menu);
  connect(file_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(file_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));
	QObject::connect( this,SIGNAL( signalMakeMenu(QPopupMenu *,const QObject *,const char *)),
										gFolders,SLOT( slotMakeMenu(QPopupMenu *,const QObject *,const char *)) );
	QObject::connect( this,SIGNAL( signalSendQueuedMessages() ) ,
										gFolders,SLOT( checkForQueuedMessages() ) );
}	else {
  ///////////////////////////////////////////////////////////////////
  // menuBar entry help_menu
  QString aboutstring=kapp->appName()+" "+VERSION+"\n\n";
  help_menu = kapp->getHelpMenu(true, aboutstring );


  menuBar()->insertItem(i18n("&Help"), help_menu);
}
  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages


}

void KImap::initToolBar()
{

  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  toolBar()->insertButton(Icon("filenew.xpm"), ID_FILE_COMPOSE, true, i18n("New Message") );
  toolBar()->insertButton(Icon("filefloppy.xpm"), ID_FILE_SAVE_FILE, true, i18n("Save to File") );
  toolBar()->insertButton(Icon("fileprint.xpm"), ID_FILE_PRINT, true, i18n("Print") );
  toolBar()->insertSeparator();
  toolBar()->insertButton(Icon("filereply.xpm"), ID_MESSAGE_REPLY, true, i18n("Reply") );
  toolBar()->insertButton(Icon("filereplyall.xpm"), ID_MESSAGE_REPLYALL, true, i18n("Reply all") );
  toolBar()->insertButton(Icon("fileforward.xpm"), ID_MESSAGE_FORWARDINLINE, true, i18n("Forward") );
  toolBar()->insertButton(Icon("filedel2.xpm"), ID_MESSAGE_DELETE, true, i18n("Delete") );
  toolBar()->insertSeparator();
  toolBar()->insertButton(Icon("openbook.xpm"), ID_FILE_ADDRESSBOOK, true, i18n("Open Addressbook"));
  toolBar()->insertSeparator();
  toolBar()->insertButton(Icon("help.xpm"), ID_HELP_CONTENTS, SIGNAL(clicked() ),
  				kapp, SLOT( appHelpActivated() ), true,i18n("Help"));

  ///////////////////////////////////////////////////////////////////
  // INSERT YOUR APPLICATION SPECIFIC TOOLBARS HERE WITH toolBar(n)


  ///////////////////////////////////////////////////////////////////
  // CONNECT THE TOOLBAR SLOTS WITH SIGNALS - add new created toolbars by their according number
	// connect for invoking the slot actions
  connect(toolBar(), SIGNAL(clicked(int)), SLOT(commandCallback(int)));
	// connect for the status help on holing icons pressed with the mouse button
  connect(toolBar(), SIGNAL(pressed(int)), SLOT(statusCallback(int)));

}

void KImap::initStatusBar()
{
	setStatusBar(mStatusBar = new NMStatusBar(this,"KImap_statusbar"));
}

bool  KImap::event(QEvent *e)
{
	bool retval;
	
//	debug("KImap::event(%d)",e->type());
	
	if(e->type() == Event_Hide) // sorry wont work
	{
		hide();
		return false;
	}
	retval = KTMainWindow::event(e);
	
	return retval;
}

void KImap::checkForQueuedMsg()
{
	KConfig *config=kapp->getConfig();
	KGroupIterator *git=config->groupIterator();
	
	if(git) {
  	while(git->current()) {
			if(!strncmp("Identity",git->currentKey(),8))
			{
 				debug("Processing %s",git->currentKey());
 				config->setGroup(git->currentKey());
  			QString saveSend = config->readEntry("Save Send");
  			if(!saveSend.isEmpty()) {
/*  				debug("Checking for Queued Msgs in : %s",saveSend.data());
  				NMFolderContent *qMsg = new NMFolderContent();
  				qMsg->show();
  				qMsg->slotFolder(saveSend.data());
*/  				//delete qMsg;
  			}
 			}
		  git->operator++();
  	}
    delete git;
		git = NULL;
  }
}

KImapView *KImap::getView()
{
	return view;
}

void KImap::checkForQueuedMsg(const char *)
{
}

//-----------------------------------------------------------------------------
void KImap::slotUrlClicked(const char* aUrl, int)
{
  KMComposeWin *win;

  if (!strnicmp(aUrl, "mailto:", 7))
  {
    mailMessage *msg = new mailMessage;
    msg->setMessageTo(aUrl+7);

    win = new KMComposeWin(msg);
    win->show();
  }
  else if (!strnicmp(aUrl, "http:", 5) || !strnicmp(aUrl, "ftp:", 4) ||
	   !strnicmp(aUrl, "file:", 5))
  {
    slotStatusMsg(i18n("Opening URL..."));
    system("kfmclient openURL \""+QString(aUrl)+"\"");
  } else {
		debug("KImap::slotUrlClicked unknown URL Type '%s'",aUrl);
  }
}

