/***************************************************************************
                          kimapview.h  -  description
                             -------------------
    begin                : Sun Dec 19 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KIMAPVIEW_H
#define KIMAPVIEW_H

#include <qwidget.h>

class NMClient;
class QSplitter;
class QListViewItem;
class MailStream;
class NMMailView;
class NMListFolders;
class NMFolderContent;

/**
  *@author Sven Carstens
  */

class KImapView : public QWidget  {
   Q_OBJECT
public: 
//	KImapView(NMClient *,QWidget *parent=0, const char *box=0);
	KImapView(QWidget *parent=0, const char *box=0);
	~KImapView();

	void readConfig();
	void writeConfig(bool withSync=true);
  void reOpen();

public slots:
//	void slotInsertFolder(const char *a) { emit signalInsertFolder(a); }
//	void slotInsertFolder(const char *a,const char *b) { emit signalInsertFolder(a,b); }
//	void slotFolder(QListViewItem *);
	void slotFolder(const char *);
	void slotFolder(int);
//	void slotMail(QListViewItem *);

	void slotFolderUp();
	void slotFolderDown();
	void slotFolderExpand();
	void slotFolderCollapse();

	void slotMessageUp();
	void slotMessageDown();
	void slotMessageExpand();
	void slotMessageCollapse();

	void print(QPrinter*);

protected:
	virtual void closeEvent(QCloseEvent *);
	
signals:
//	void signalInsertFolder(const char *);
//	void signalInsertFolder(const char *,const char *);
//	void signalFolder(NMClient *,const char *);
//	void signalMail(NMClient *,unsigned long);
//	void signalStatusMsg(const char *);

public:
	class NMListFolders *folders;
	class NMMailView *mailview;
	class NMFolderContent *overview;

private:
	class QSplitter *uppersplitter;
	class QSplitter *lowersplitter;
//	class NMClient *client;

protected:
    void   resizeEvent( QResizeEvent * );
};

#endif
