/***************************************************************************
                          nmdocking.h  -  description
                             -------------------
    begin                : Wed Dec 29 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * $Id: docking.h,v 1.3 1998/10/25 19:22:28 mario Exp $
 *
 *              Copyright (C) 1997 Bernd Johannes Wuebben
 *                      wuebben@math.cornell.edu
 *
 * This file was contributed by Harri Porten <porten@tu-harburg.de>
 *
 */


#ifndef _DOCKING_H_
#define _DOCKING_H_

#include <stdio.h>
#include <qapp.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qpopmenu.h>
#include <qpoint.h>

class DockWidget : public QWidget {
  Q_OBJECT
public:
  DockWidget(const char *name=0);
  ~DockWidget();

protected:
  void paintEvent(QPaintEvent *e);

private slots:
  void mousePressEvent(QMouseEvent *e);

public slots:
  void toggle_window_state();
  void dock();
  void undock();
  void paintIcon();

public:
  const bool isDocked();
  static DockWidget *dock_widget;
	void setWorking(bool);
	void recent();
	void unseen();
	void none();

private:
  bool docked;
	bool working;
  int toggleID;
	int checkID;
	bool recentWaiting;
	QString actionUnseen;
  QPopupMenu *popup_m;

  QPixmap dock_none_pixmap;
  QPixmap dock_new_pixmap;
  QPixmap dock_old_pixmap;
	QPixmap dock_work_pixmap;
	QPixmap *default_pixmap;
};

#endif
