/***************************************************************************
                          nmglobalfolders.cpp  -  description
                             -------------------
    begin                : Sat May 27 2000
    copyright            : (C) 2000 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nmglobalfolders.h"
#include <kapp.h>
#include <malloc.h>
#include <qlist.h>
#include <qlayout.h>
#include <qdialog.h>
#include <qbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <ktmainwindow.h>
#include "kimapview.h"
#include "extern.h"
#include "kbusyptr.h"
#include "nmdocking.h"
#include "nmstatusbar.h"
#include "nmselect.h"
#include "resource.h"
#include "kimap.h"
#include "kmidentity.h"
#include <kiconloader.h>
#include <kfiledialog.h>
#include <qmessagebox.h>
#include <qdir.h>

realFolder::realFolder(){}

realFolder::~realFolder(){}

bool realFolder::parseUWIFolder(const char *aFolder)
{
		QString work = aFolder;
		protocol = "";
		host = "";
		path = "";
		user = "";
		port = "";
		check = false;
						
//do we have a specification from cpp-client ?
		if(work.find('{') == 0)
		{
			int sep;
//separate host and path
			sep = work.find('}');
			path = work.right(work.length() - sep -1 );
			host = work.left(sep);
			host = host.right( host.length() - 1 );

			sep = host.find('/');
			work = host.right( host.length() - sep -1);
//tie off arguments
			host = host.left(sep);

//tie off port
			if(host.find(":") != -1)
			{
  			port = host;
  			port = port.right( port.length() - port.find(':')-1 );
  			host = host.left(host.find(':'));
			} else {
				port = "";
			}
			
			while( !work.isEmpty() ) {
				sep = work.find('/');

				if( work.findRev('=',sep) != -1 )
				{
					if( work.findRev("user",sep,false) != -1 )
					{
						user = work.left(sep);
						user = user.right( user.length() - user.find('=') - 1);
					}
				} else
					if(stricmp(work.left(sep),"secure"))
					{
						if(stricmp(work.left(sep),"check"))
						{
						 if(protocol.isEmpty()) protocol = (work.left(sep)).lower();
						} else {
							check = true;
						}
					}

				if(sep == -1) work = "";
				else work = work.right( work.length() - sep - 1 );
			}
		} else if(aFolder[0] == '#'){
			work = &aFolder[1];
			path = work.right( work.length() - work.find('/') );
			protocol = (work.left( work.find('/') )).lower();
			user = "";
			host = "";
			port = "";
		} else { /*if(stricmp("INBOX",aFolder)) { */
			host = "";
			path = aFolder;
			protocol = "file";
			user = "";
			port = "";
 /*		} else {
			host = "";
			path = "";
			protocol = "inbox";
			user = "";
			port = ""; */
		}
		if(protocol.isEmpty()) protocol = "imap";
	return true;
}

bool realFolder::parseURIFolder(const char *aFolder)
{
	QString work;
	bool retval = true;	
	work = aFolder;
		
		protocol = "";
		host = "";
		path = "";
		user = "";
		port = "";
		check = false;
	
	//everything up to : is the protocol
	if(work.find(":") != -1)
	{
  	protocol = work.left(work.find(":"));
  	work = work.right(work.length() - work.find(":") - 1);
//  	debug("protocol %s rest %s",protocol.data(),work.data());
		if(!strncmp("//",work.data(),2))
		{
			//this is a remote specification
	  	work = work.right(work.length() - 2);
	  	path = work.right(work.length() - work.find("/") - 1);
	  	work = work.left(work.find("/"));
	  	//the last @ separates the host
	  	if(work.findRev("@") != -1)
	  	{
  	  	user = work.left(work.findRev("@"));
  	  	work = work.right(work.length() - work.findRev("@") - 1);
//  	  	debug("user %s rest %s",user.data(),work.data());
	  	}
	  	//the : separates the port
	  	host = work.left(work.find(":"));
	  	if(work.find(":") != -1)
	  	{
		  	port = work.right(work.length() - work.find(":") - 1);
		  	port.toInt(&retval);
		  }
	  	work = "";
//	  	debug("host %s port %s rest %s",host.data(),port.data(),work.data());
		} else if(!strncmp("/",work.data(),1)) {
	  	path = work.right(work.length() );
	  	work = "";
		} else {
			if(!stricmp("INBOX",work.data()))
			{
				path = "INBOX";
			} else {
				retval = false;
			}
		}
//  	debug("path %s rest %s",path.data(),work.data());
	} else {
		retval = false;
	}
//	debug("%s : %s",retval ? "TRUE" : "FALSE",aFolder);
	return retval;
}

bool realFolder::parseFolder(const char *aFolder)
{
	if(!parseURIFolder(aFolder))
		return parseUWIFolder(aFolder);
	return true;
}

char *realFolder::assembleUWIFolder()
{
	static QString work;
	work = "";
	
	if(protocol.isEmpty()) return NULL;
	if(!host.isEmpty())
	{
  	work = QString("{") + host;
  	if(!port.isEmpty()) work += ":" + port;
  	if(!protocol.isEmpty()) work += "/" + protocol.left(protocol.findRev("s"));
  	if(!user.isEmpty()) work += QString("/user=") + user;
  	if(protocol[protocol.length()-1 ] == 's' ) work += "/ssl/novalidate-cert";
		work += "}";
	} else {
		if(stricmp("file",protocol))
			work = QString("#") + protocol;
	}
	work += path;
//	debug("Generated UWI: %s",work.data());
	return work.data();
}

char *realFolder::assembleURIFolder()
{
	static QString work;
	
	if(protocol.isEmpty()) return NULL;
	work = protocol + ":";
	if(!host.isEmpty()) work += "//";
	if(!user.isEmpty()) work += user + "@";
	if(!host.isEmpty()) work += host;
	if(!port.isEmpty()) work += ":" + port;
	if(!host.isEmpty()) work += "/";
	work += path;
	return work.data();
}

NMGlobalFolders::NMGlobalFolders()
	:	QObject()
{
	mFolders.setAutoDelete( true );
	mLists.setAutoDelete( false );
	
	checkRecent = 0;
	checkUnseen = 0;

	dontTellDocking = false;
		
	timerEvent(NULL); // initialize timer
}

NMGlobalFolders::~NMGlobalFolders(){
}

void NMGlobalFolders::writeFolders(KApplication *mApp)
{
  KConfig *config = mApp->getConfig();
  config->setGroup("Folders");

	//first write the deletions
  for(int i=getNOF();i>0;i--)
  {
		if(getAt(i-1))
		{
			QString entry = getAt(i-1)->getVirtual();
			
			if(entry[0] == '#') entry = QString("\\") + entry;
			if(getAt(i-1)->isDeleted())
				config->writeEntry(entry,"");
//			else
//				config->writeEntry(entry,getAt(i-1)->assembleURIFolder());
		}
  }

	//then the final folders
  for(int i=getNOF();i>0;i--)
  {
		if(getAt(i-1))
		{
			QString entry = getAt(i-1)->getVirtual();
			
			if(entry[0] == '#') entry = QString("\\") + entry;
			if(getAt(i-1)->isDeleted())
//				config->writeEntry(entry,"");
				;
			else
				config->writeEntry(entry,getAt(i-1)->assembleURIFolder());
		}
  }
  config->setGroup("Check");
  for(int i=getNOF();i>0;i--)
  {
		if(getAt(i-1) && getAt(i-1)->getCheck() && !getAt(i-1)->isDeleted())
			config->writeEntry(getAt(i-1)->assembleURIFolder(),true);
  }
}

void NMGlobalFolders::readFolders(KApplication *mApp)
{
  KConfig *config = mApp->getConfig();
	KEntryIterator *entryIterator;
	const char *data;
	char *key;
	realFolder *nFolder;
	mFolders.clear();
	
	debug("Initializing Global Folders");
  config->setGroup("Folders");
	entryIterator = config->entryIterator("Folders");
	if(entryIterator) {
  	while(entryIterator->current()) {
			data = entryIterator->current()->aValue.data();
			key = (char *)entryIterator->currentKey();
			if(key[0] == '\\') key++;
			if(data && *data) //ignore empty entries. see writeFolders for details
			{
				nFolder = new realFolder();
				if(nFolder)
				{
					nFolder->parseFolder(data);
					nFolder->setVirtual(key);
					nFolder->setUnseen(0);
					nFolder->setRecent(0);
					nFolder->setTotal(0);
					nFolder->setCheck(false);
					nFolder->setDeleted(false);
					nFolder->setView(NULL);
					mFolders.append( nFolder );
				} else {
					debug("NMGlobalFolders: Out of memory");
				}
			}
		  entryIterator->operator++();
  	}
    delete entryIterator;
  }
  config->setGroup("Check");
  for(int i=getNOF();i>0;i--)
  {
		getAt(i-1)->setCheck(config->readBoolEntry(getAt(i-1)->assembleURIFolder(),false));
  }

}

bool operator==(realFolder &one,realFolder &two)
{			
			if(one.getPath() == two.getPath()) {
				if(one.getPort() == two.getPort()) {
					if(one.getHost() == two.getHost()) {
						if(one.getUser() == two.getUser()) {
							if(one.getProtocol() == two.getProtocol()) return true;
							//else debug("== protocol mismatch");
						} //else { debug("== User mismatch"); }
					} //else { debug("== Host mismatch"); }
				} //else { debug("== Port mismatch %s %s",one.getPort().data(),two.getPort().data()); }
			} //else { debug("== Path mismatch %s %s",one.getPath().data(),two.getPath().data()); }
	
	return false;
}

realFolder *NMGlobalFolders::getAt(int where)
{
	if(mFolders.at(where)) return mFolders.at(where);
	return NULL;
}

int NMGlobalFolders::getNOF()
{
	return mFolders.count();
}

realFolder *NMGlobalFolders::findFolder(const char *aFolder)
{
	realFolder *work = NULL;
	
	if(aFolder)
	{
		mFolders.first();
		realFolder temp;
		
		temp.parseFolder(aFolder);
		while(mFolders.current() && (work = mFolders.current()))
		{
			if(*work == temp) break;
			work = NULL;
			mFolders.next();
		}
	}
	return work;
}

realFolder *NMGlobalFolders::findVirtual(const char *aFolder)
{
	realFolder *work = NULL;
	
	if(aFolder)
	{
		mFolders.first();
		
		while(mFolders.current() && (work = mFolders.current()))
		{
			if(work->getVirtual() == aFolder) break;
			work = NULL;
			mFolders.next();
		}
	}
	return work;
}

void NMGlobalFolders::editProperties(const char *aFolder)
{
	if(aFolder)
	{
			editProperties(findFolder(aFolder),false);
	}
}

const char *NMGlobalFolders::renameFolder(const char *aVirtual)
{
	realFolder *temp;
	static QString retval = "";
	
	if(aVirtual)
	{
		temp = findVirtual(aVirtual);
		if(temp)
		{		
			//this is a folder
			retval = renameFolder(temp);
		} else {
			//renaming a parent
			temp = new realFolder;
			temp->setVirtual(aVirtual);
			emit signalChanged(mFolders.findRef(temp),temp);
			retval = renameFolder(temp);
			if(retval)
			{
				//rename all folders that include the path
       	realFolder *work = NULL;
       	
     		mFolders.first();
       		
     		while(mFolders.current() && (work = mFolders.current()))
     		{
     			if(work->getVirtual().find(aVirtual) == 0)
     			{
     				work->setVirtual(
     					QString(retval) +
     					work->getVirtual().right(
     						work->getVirtual().length() - strlen(aVirtual)
     					)
     				);
     				emit signalChanged(mFolders.findRef(work),work);
	     		}
     			mFolders.next();
     		}
			}
			delete temp;
		}
	}
	if(retval.isEmpty()) return NULL;
	return retval.data();
}

void NMGlobalFolders::editProperties(int aNum)
{
	editProperties(getAt(aNum),false);
}

void NMGlobalFolders::editProperties(realFolder *aFolder,bool change)
{
	if(!aFolder) return;
	QDialog *dialog = new QDialog(NULL,"folderproperties",true);
  QGridLayout* grid = new QGridLayout(dialog, 9, 4, 8, 8);
  QPushButton *btnOk, *btnCancel;
  QLabel *label;
  int h, w1, w2;

  dialog->resize(320, 190);
	dialog->setCaption(i18n("Folder Properties"));

  //-----
  QLineEdit *mEdtVirtual = new QLineEdit(dialog);
  mEdtVirtual->adjustSize();
  h = mEdtVirtual->sizeHint().height();
  mEdtVirtual->setMinimumSize(100, h);
  mEdtVirtual->setMinimumSize(100, h);
  mEdtVirtual->setMaximumSize(1024, h);
  //-----

  label = new QLabel(i18n("Virtual Path:"),dialog);
  label->adjustSize();
  label->setMinimumSize(100, h);
  grid->addMultiCellWidget(label, 0, 0, 0, 0);
  grid->addMultiCellWidget(mEdtVirtual, 0, 0, 1, 3);

  //-----
  label = new QLabel(i18n("Server:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 1, 0);

  QLineEdit *mEdtServer = new QLineEdit(dialog);
  mEdtServer->setMinimumSize(100, h);
  mEdtServer->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtServer, 1, 1, 1, 3);

  //-----
  label = new QLabel(i18n("Protocol:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 2, 0);

  QLineEdit *mEdtProto = new QLineEdit(dialog);
  mEdtProto->setMinimumSize(100, h);
  mEdtProto->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtProto, 2, 2, 1, 3);

  //-----
  label = new QLabel(i18n("Port:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 3, 0);

  QLineEdit *mEdtPort = new QLineEdit(dialog);
  mEdtPort->setMinimumSize(100, h);
  mEdtPort->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtPort, 3, 3, 1, 3);

  //-----
  label = new QLabel(i18n("User:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 4, 0);

  QLineEdit *mEdtUser = new QLineEdit(dialog);
  mEdtUser->setMinimumSize(100, h);
  mEdtUser->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtUser, 4, 4, 1, 3);

  //-----
  label = new QLabel(i18n("Path:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 5, 0);

  QLineEdit *mEdtPath = new QLineEdit(dialog);
  mEdtPath->setMinimumSize(100, h);
  mEdtPath->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtPath, 5, 5, 1, 3);

  //-----
  label = new QLabel(i18n("Use SSL:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 6, 0);

  QCheckBox *mEdtSecure = new QCheckBox(dialog);
  mEdtSecure->setMinimumSize(100, h);
  mEdtSecure->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtSecure, 6, 6, 1, 3);

#ifndef HAVE_OPENSSL
	mEdtSecure->setEnabled(false);
	label->setEnabled(false);
#endif

  //-----
  label = new QLabel(i18n("Check for new mail:"), dialog);
  label->adjustSize();
  label->setMinimumSize(label->sizeHint().width(), h);
  grid->addWidget(label, 7, 0);

  QCheckBox *mEdtCheck = new QCheckBox(dialog);
  mEdtCheck->setMinimumSize(100, h);
  mEdtCheck->setMaximumSize(1024, h);
  grid->addMultiCellWidget(mEdtCheck, 7, 7, 1, 3);

  mEdtVirtual->setEnabled(FALSE);
  mEdtProto->setEnabled(FALSE);
	{
		mEdtServer->setText( aFolder->getHost() );
		mEdtPath->setText( aFolder->getPath() );
		mEdtProto->setText( aFolder->getProtocol().left(aFolder->getProtocol().findRev("s")) );
		mEdtUser->setText( aFolder->getUser() );
		mEdtPort->setText( aFolder->getPort() );
		mEdtSecure->setChecked( aFolder->getProtocol()[aFolder->getProtocol().length()-1 ] == 's' );
		mEdtCheck->setChecked( aFolder->getCheck() );
	}
	mEdtVirtual->setText(aFolder->getVirtual());

  //-----
  btnOk = new QPushButton(i18n("OK"), dialog);
  btnOk->adjustSize();
  btnOk->setMinimumSize(btnOk->sizeHint());
  QObject::connect(btnOk, SIGNAL(clicked()),dialog, SLOT(accept()));
  grid->addMultiCellWidget(btnOk, 8, 8, 0, 1);

  btnCancel = new QPushButton(i18n("Cancel"), dialog);
  btnCancel->adjustSize();
  btnCancel->setMinimumSize(btnCancel->sizeHint());
  QObject::connect(btnCancel, SIGNAL(clicked()),dialog, SLOT(reject()));
  grid->addMultiCellWidget(btnCancel, 8, 8, 2, 3);

  h  = btnOk->sizeHint().height();
  w1 = btnOk->sizeHint().width();
  w2 = btnCancel->sizeHint().width();
  if (w1 < w2) w1 = w2;
  if (w1 < 120) w1 = 120;
  btnOk->setMaximumSize(w1, h);
  btnCancel->setMaximumSize(w1, h);

  //-----
  grid->setColStretch(0, 0);
  grid->setColStretch(1, 10);
  grid->setColStretch(3, 10);
  grid->activate();

  dialog->adjustSize();
	if(dialog->exec())
	{
 		aFolder->setPort(mEdtPort->text());
 		aFolder->setProtocol(mEdtProto->text());
 		aFolder->setProtocol(aFolder->getProtocol() + (mEdtSecure->isChecked() ? "s" : ""));
 		aFolder->setUser(mEdtUser->text());
 		aFolder->setPath(mEdtPath->text());
 		aFolder->setHost(mEdtServer->text());
 		aFolder->setVirtual(mEdtVirtual->text());
 		aFolder->setCheck(mEdtCheck->isChecked());
		emit signalChanged(mFolders.findRef(aFolder),aFolder);
	}
}

const char *NMGlobalFolders::renameFolder(int aNum)
{
	return renameFolder(getAt(aNum));
}

const char *NMGlobalFolders::renameFolder(realFolder *aFolder)
{	
	char *retval;
	QDialog *dialog = new QDialog(NULL,NULL,true);
	QHBoxLayout *hlayout = new QHBoxLayout();
	QVBoxLayout *vlayout = new QVBoxLayout(dialog);
	QPushButton *btn;


  dialog->setCaption(i18n("Rename"));

  QLabel *label;
  if(aFolder)
  {
  	label = new QLabel(aFolder->getVirtual(),dialog);
    label->setMinimumSize(label->sizeHint());
  	vlayout->addWidget(label);
  	label = new QLabel(aFolder->assembleURIFolder(),dialog);
    label->setMinimumSize(label->sizeHint());
  	vlayout->addWidget(label);
  }

	QLineEdit *edit;
	edit = new QLineEdit(dialog);
	if(aFolder) edit->setText( aFolder->getVirtual() );
	edit->setMinimumSize(edit->sizeHint());
	vlayout->addWidget(edit);

	vlayout->addLayout(hlayout);

  btn = new QPushButton(i18n("Rename") ,dialog,"NULL");
  btn->setMinimumSize(btn->sizeHint());
  QObject::connect(btn,SIGNAL(pressed()),dialog,SLOT(accept()));
	hlayout->addWidget(btn);

  btn = new QPushButton(i18n("Cancel"), dialog);
  btn->setMinimumSize(btn->sizeHint());
  QObject::connect(btn,SIGNAL(pressed()),dialog,SLOT(reject()));
	hlayout->addWidget(btn);

	edit->setFocus();

	retval = NULL;
	if( dialog->exec() && aFolder)
	{
		aFolder->setVirtual(edit->text());
		retval = aFolder->getVirtual().data();
		emit signalChanged(mFolders.findRef(aFolder),aFolder);
	}
  delete dialog;

  return retval;
}

void NMGlobalFolders::deleteFolder(const char *aFolder)
{
	QDialog *dialog = new QDialog(NULL,NULL,true);
	QHBoxLayout *hlayout = new QHBoxLayout();
	QVBoxLayout *vlayout = new QVBoxLayout(dialog);
	QPushButton *btn;

  dialog->setCaption(i18n("Delete"));

  QLabel *label;
	label = new QLabel(aFolder,dialog);
  label->setMinimumSize(label->sizeHint());
	vlayout->addWidget(label);
	
	realFolder *temp=NULL;
	if((temp = findVirtual(aFolder)))
	{
  	label = new QLabel(temp->assembleURIFolder(),dialog);
    label->setMinimumSize(label->sizeHint());
  	vlayout->addWidget(label);
	}
 	vlayout->addLayout(hlayout);

  btn = new QPushButton(i18n("Delete") ,dialog,"NULL");
  btn->setMinimumSize(btn->sizeHint());
  QObject::connect(btn,SIGNAL(pressed()),dialog,SLOT(accept()));
	hlayout->addWidget(btn);

  btn = new QPushButton(i18n("Cancel"), dialog);
  btn->setMinimumSize(btn->sizeHint());
  QObject::connect(btn,SIGNAL(pressed()),dialog,SLOT(reject()));
	hlayout->addWidget(btn);

	if(aFolder && dialog->exec() )
	{
		if(temp)
		{
			doDeleteFolder(aFolder);
		} else {
			doDeleteFolder(QString(aFolder) + "/");
		}
	}
  delete dialog;
}

void NMGlobalFolders::doDeleteFolder(const char *aFolder)
{			
	if(aFolder)
	{
		//delete all folders that include the path
   	realFolder *work = NULL;
 		mFolders.first();
       		
 		while(mFolders.current() && (work = mFolders.current()))
 		{
 			if(work->getVirtual().find(aFolder) == 0)
 			{
// 				debug("Deleting %s because of request to delete %s",work->getVirtual().data(),aFolder);
 				mFolders.current()->setDeleted(true);
				emit signalChanged(mFolders.findRef(work),work);
 			}
 			mFolders.next();
 		}
	}
}

void NMGlobalFolders::slotStatus(NMClient *client,char *mailbox,MAILSTATUS *status)
{
 	realFolder *aFolder;
	realFolder *savePtr;
	 	
 	if(client)
	{
		//change: iterate over all folders
  	if(client->getBox())
  	{
  		savePtr = mFolders.current(); //restore it later, or other iterators will fail
  		mFolders.first();
  		realFolder temp;
  		
  		temp.parseFolder(client->getBox());
  		while((aFolder = mFolders.current()))
  		{
  			if(*aFolder == temp)
  			{
    			int old_unseen=0;
    			int old_recent=0;
    			unsigned int old_messages=0;

    			old_unseen = aFolder->getUnseen();
    			old_recent = aFolder->getRecent();
    			old_messages = aFolder->getTotal();

    			aFolder->setRecent(status->recent);
    			aFolder->setUnseen(status->unseen);
    			aFolder->setTotal(status->messages);
    			
    			if(aFolder->getView())
    			{
    				//someone has to tell us how many messages were
    				//read so far in the currentFolder
    				//as the status is not updated on the server
    				//until we close and reopen the folder
    				//or do an expunge on it
    				//nmfoldercontent knows about it (I hope)
    				QObject::connect( this, SIGNAL( signalReadSoFar() ) ,
    													aFolder->getView(), SLOT( slotReadSoFar() ) );
    				emit signalReadSoFar();
    				QObject::disconnect( this, SIGNAL( signalReadSoFar() ) ,
    													aFolder->getView(), SLOT( slotReadSoFar() ) );
     			
    				if(old_messages > 0 && old_messages < status->messages)
    				{
      				QObject::connect( this, SIGNAL( signalRefresh() ) ,
      													aFolder->getView(), SLOT( slotRefresh() ) );
    					emit signalRefresh();
      				QObject::disconnect( this, SIGNAL( signalRefresh() ) ,
      													aFolder->getView(), SLOT( slotRefresh() ) );
    				}
    			}
    			if(aFolder->getCheck()) // things have been subtracted twice so far
    			{
    				checkUnseen += (status->unseen - old_unseen);
    				checkRecent += (status->recent - old_recent);
    			}
    			debug("%s : recent %d unseen %d total %d",aFolder->assembleURIFolder(),aFolder->getRecent(),aFolder->getUnseen(),aFolder->getTotal());
    			statusChange( aFolder );
  			
  			}
  			mFolders.next();
  		}
  		mFolders.findRef(savePtr); //restore the saved current item
  	}
	}
}

void NMGlobalFolders::slotNFolder( realFolder *aFolder )
{
 	if(!aFolder->getView())
 	{
 		//generate a new view
 		QString aUWIFolder = aFolder->assembleUWIFolder();
 		debug("Showing box : %s",aUWIFolder.data());
 		KTMainWindow *master = new KTMainWindow();
		initPreMenuBar(master);			  		
 		KImapView *new_view = new KImapView(master,"");
 		master->setView(new_view);
		initPostMenuBar(master);			  		
 		master->show();
 		new_view->slotFolder(mFolders.findRef(aFolder));
 	} else {
 		// raise the old view
 		aFolder->getView()->setFocus();
 		aFolder->getView()->show();
 		aFolder->getView()->raise();
 	}
}

void NMGlobalFolders::slotNFolder( const char *aVirtual )
{
	realFolder *aFolder = findVirtual(aVirtual);
	
	if(aFolder)
	{
		slotNFolder(aFolder);
  } else {
		debug("Folder not found : %s",aVirtual);
  }
}

void NMGlobalFolders::slotNFolder( int aNum )
{
	realFolder *aFolder = mFolders.at(aNum);
	
	if(aFolder)
	{
		slotNFolder(aFolder);
  } else {
		debug("Folder not found : %d",aNum);
  }
}

void NMGlobalFolders::slotFolder( const char *aVirtual )
{
	realFolder *aFolder = findVirtual(aVirtual);
	
	if(aFolder)
	{
		slotFolder(aFolder);
  } else {
		debug("Folder not found : %s",aVirtual);
  }
}

void NMGlobalFolders::slotFolder( int aNum )
{
	realFolder *aFolder = mFolders.at(aNum);
	
	if(aFolder)
	{
		slotFolder(aFolder);
  } else {
		debug("Folder not found : %d",aNum);
  }
}

void NMGlobalFolders::slotFolder( realFolder *aFolder )
{
 	if(!aFolder) return;
 	if(!aFolder->getView())
 	{
 		//set the folder in main view
 		QString aUWIFolder = aFolder->assembleUWIFolder();
 		debug("Showing box : %s",aUWIFolder.data());
		if(kimap && kimap->getView())
		{
			kimap->getView()->slotFolder(mFolders.findRef(aFolder));
		}
 	} else {
 		// raise the old view
 		aFolder->getView()->setFocus();
 		aFolder->getView()->show();
 		aFolder->getView()->raise();
 	}
}

void NMGlobalFolders::slotSignOff(QWidget *aView)
{     		
	mFolders.first();
       		
	debug("Signing off : %p",aView);
	while(mFolders.current())
	{
		if( mFolders.current()->getView() == aView)
		{
			debug("Removed from %s",mFolders.current()->assembleURIFolder());
			mFolders.current()->setView(NULL);
		}
		mFolders.next();
	}
}

void NMGlobalFolders::slotSignOn(realFolder *mFolder,NMFolderContent *aWidget)
{
	if(mFolder->getView() != NULL)
	{
		debug("NMGlobalFolders::slotSignOn view is already taken by %p requested by %p",mFolder->getView(),aWidget);
	}
	debug("NMGlobalFolders::slotSignOn %p to %s , ? [%p]",aWidget,mFolder->getVirtual().data(),mFolder);
	mFolder->setView(aWidget);
}

void NMGlobalFolders::slotSignOn(int aNum,NMFolderContent *aWidget)
{
		slotSignOn(getAt(aNum),aWidget);
}

void NMGlobalFolders::slotSignOff(int aNum,NMFolderContent *aWidget)
{
	realFolder *mFolder = getAt(aNum);
	
	if(mFolder)
	{
		if(mFolder->getView() == NULL)
		{
			debug("NMGlobalFolders::slotSignOff view is not registered to %p",aWidget);
		}
		else if(mFolder->getView() != aWidget)
		{
			debug("NMGlobalFolders::slotSignOff view is not registered to %p but to %p",aWidget,mFolder->getView());
		} else {
			debug("NMGlobalFolders::slotSignOff %p from %s , ? [%p]",aWidget,mFolder->getVirtual().data(),mFolder);
			mFolder->setView(NULL);
		}
	} else {
		debug("NMGlobalFolders::slotSignOff couldnt find folder %d",aNum);
	}
}

void NMGlobalFolders::slotStatusLookup()
{
	slotStatusLookup(false);
}

void NMGlobalFolders::slotStatusLookup(bool checkall)
{
 	realFolder *work;
	NMClient my_stream;
	
	QObject::connect( &my_stream,SIGNAL(signalStatus(NMClient *,char *,MAILSTATUS *)),
										gFolders, SLOT(slotStatus(NMClient *,char *,MAILSTATUS *)) );
	NMStatusBar::connectToStatusBar(&my_stream,kimap);
  debug("Doing Status Lookup on %s folders.",checkall ? "all" : "selected");										
	kbp->busy();
	if(checkall)
		my_stream.progressNotify(mpSTART,0,i18n("Checking all Folders"));
	else
		my_stream.progressNotify(mpSTART,0,i18n("Checking selected Folders"));
 		
 	mFolders.first();
       		
 	dontTellDocking = true;
	dock->setWorking(true);
 	
 	while((mFolders.current()) && (work = mFolders.current()))
 	{
 		if(work->getCheck() || checkall)
 		{
		  debug("Doing Status Lookup on %s.",work->assembleUWIFolder());										
	 		my_stream.progressNotify(mpSET_DELTA,1,NULL);
			my_stream.Status(work->assembleUWIFolder());
		}
 		mFolders.next();
 	}
	my_stream.progressNotify(mpSTOP,0,NULL);
 			
 			debug("Calling Docking Unseen: [%d], Recent: [%d]",checkUnseen,checkRecent);

 			if(checkRecent) dock->recent();
 			else if(checkUnseen) dock->unseen();
 			else dock->none();
	
	dontTellDocking = false;
	dock->setWorking(false);

	kbp->idle();	
}

void NMGlobalFolders::slotStatusLookup(const char *aFolder)
{
	slotStatusLookup(findVirtual(aFolder));
}

void NMGlobalFolders::slotStatusLookup(int aNum)
{
	slotStatusLookup(getAt(aNum));
}

void NMGlobalFolders::slotStatusLookup(realFolder *aFolder)
{
	if(aFolder)
	{		
		NMClient my_stream;
  	
  	QObject::connect( &my_stream,SIGNAL(signalStatus(NMClient *,char *,MAILSTATUS *)),
  										gFolders, SLOT(slotStatus(NMClient *,char *,MAILSTATUS *)) );
		NMStatusBar::connectToStatusBar(&my_stream,kimap);
		
	  debug("Doing Status Lookup on %s.",aFolder->assembleUWIFolder());										
		my_stream.Status(aFolder->assembleUWIFolder());
	}
}

void NMGlobalFolders::timerEvent(QTimerEvent *ev)
{
	KConfig *config = kapp->getConfig();
	
	killTimers();
	debug("NMGlobalFolders::timerEvent - killedTimers");
	if(ev)
	{
		slotStatusLookup(false);
	}
	config->setGroup("General");
	int val = config->readNumEntry("check-mail-interval") * 60 * 1000;
	if(val > 0)
	{
		startTimer( val );
		debug("NMGlobalFolders::timerEvent - startedTimers");
	}		
}

void NMGlobalFolders::slotSubStatus(const char *aFolder,int recent,int unseen)
{
	realFolder *mFolder;
	
	mFolder = findFolder(aFolder);
	if(mFolder)
	{
		slotSubStatus(mFolder,recent,unseen);
	} else {
		debug("NMGlobalFolders::slotSubStatus couldnt find Folder %s",aFolder);
	}
}

void NMGlobalFolders::slotSubStatus(int aNum,int recent,int unseen)
{
	slotSubStatus(getAt(aNum),recent,unseen);
}

void NMGlobalFolders::slotSubStatus(realFolder *mFolder,int recent,int unseen)
{
		debug("NMGlobalFolders::slotSubStatus %d %d",recent,unseen);
		if(mFolder->getCheck())
		{
			checkRecent += recent;
			checkUnseen += unseen;
		}
		mFolder->setRecent( mFolder->getRecent() + recent);
		mFolder->setUnseen( mFolder->getUnseen() + unseen);
		statusChange( mFolder );
}

void NMGlobalFolders::statusChange(realFolder *mFolder)
{		
		emit signalStatus( mFolder->getVirtual().data(), mFolders.findRef(mFolder), mFolder->getRecent(), mFolder->getUnseen(), mFolder->getTotal());
		if(mFolder->getCheck() && !dontTellDocking)
		{
 			debug("Calling Docking Unseen: [%d], Recent: [%d]",checkUnseen,checkRecent);

 			if(checkRecent) dock->recent();
 			else if(checkUnseen) dock->unseen();
 			else dock->none();
		}
}		

void NMGlobalFolders::slotExpunge( int aNum)
{
	slotExpunge(getAt(aNum));
}

void NMGlobalFolders::slotExpunge( realFolder *aFolder)
{
	debug("NMGlobalFolders::slotExpunge - folder is %s , %s[%p]",aFolder->getVirtual().data(),aFolder->assembleURIFolder(),aFolder);
	if(aFolder->getView())
	{
		debug("NMGlobalFolders::slotExpunge - calling current view to expunge");
		aFolder->getView()->slotFolderExpunge();
	} else {
		NMClient my_client;
	
		debug("NMGlobalFolders::slotExpunge - doing expunge myself");
  	QObject::connect( &my_client,SIGNAL(signalStatus(NMClient *,char *,MAILSTATUS *)),
  										gFolders, SLOT(slotStatus(NMClient *,char *,MAILSTATUS *)) );
		NMStatusBar::connectToStatusBar(&my_client,kimap);
		
		my_client.setBox(aFolder->assembleUWIFolder());
		my_client.expungeBox();
		my_client.Status();
		my_client.closeBox();
	}
}

void NMGlobalFolders::slotNewFolder(const char *aVirtual)
{
	QStrList *list = NULL;
	QString work;
	NMSelect *select = new NMSelect();
	
//	select->exec();
	select->show();
	while(select->result() < 0) {kapp->processEvents(1000);}
	list = select->getSelected();
	delete select;

	char  *folder;
	if(list)
	for ( folder=list->first(); folder != 0; folder=list->next() )
	{
/*		if(insertUnder)
		{
			int sep,net;

			work = folder;
			net = work.findRev('}');		
			sep = work.findRev('/');
			if(sep < net) sep = net;
			work = work.right(work.length() - sep - 1);		
  		new QListViewItem(currentPopup, work.data(),"","","",folder);
		}
		else insertFolder( folder ); */
		fprintf(stderr,"add: %s\n",folder);
 		realFolder *nFolder = new realFolder();
 		if(nFolder)
 		{
 			nFolder->parseFolder(folder);
 			if(aVirtual && *aVirtual)
 			{
 				QString lastName = nFolder->getPath();
 				lastName = lastName.right(lastName.length() - lastName.findRev('/'));
	 			nFolder->setVirtual(QString(aVirtual) + lastName);
 			} else {
 				nFolder->setVirtual(folder);
 			}
 			nFolder->setUnseen(0);
 			nFolder->setRecent(0);
 			nFolder->setTotal(0);
 			nFolder->setCheck(false);
 			nFolder->setDeleted(false);
 			nFolder->setView(NULL);
 			mFolders.append( nFolder );
 			emit signalChanged(mFolders.findRef(nFolder),nFolder);
 		} else {
 			debug("NMGlobalFolders: Out of memory");
 		}
	}
}

void NMGlobalFolders::slotMakeMenu(QPopupMenu *popup,const QObject *receiver,const char *member)
{
	QDict<QPopupMenu> mMenu;
	QPopupMenu *cur_menu;
	realFolder *item;
	
	if(!popup) return;
	popup->clear();
	mMenu.insert("",popup);
	item = mFolders.first();
	
	while(item)
	{
			QString temp = item->getVirtual();
			cur_menu = findParent(&mMenu,temp,receiver,member);
			if(cur_menu) cur_menu->insertItem( temp,mFolders.findRef(item));
			else debug("NMGlobalFolders::slotMakeMenu - found Null for %s",item->getVirtual().data());
		item = mFolders.next();
	}
	
	popup->insertSeparator();
	popup->insertItem(i18n("File ..."),mFolders.count()+1);
}

QPopupMenu *NMGlobalFolders::findParent(QDict<QPopupMenu> *dict,QString &aVirtual,const QObject *receiver,const char *member)
{
	QPopupMenu *retval;
	int sep = aVirtual.findRev('/');
	if(sep > 0 && aVirtual.at(sep-1) == '/') sep--;
		
//	debug("NMGlobalFolders::findParent - processing %s",aVirtual.data());
	if(sep <= 0) retval = dict->find("");
	else {
  	retval = dict->find(aVirtual.left(sep));
  	if(!retval) //if parent menu hasnt been created yet
  	{
  		QString temp = aVirtual.left(sep);
  		QPopupMenu *parent = findParent(dict,temp,receiver,member); //find next parent
  		
  		retval = new QPopupMenu(NULL,aVirtual.left( sep )); //generate new menu
		  connect( retval, SIGNAL(activated(int)), receiver,member ); //connect to receiver
  		if(parent) parent->insertItem(temp,retval);
  		dict->insert(aVirtual.left( sep ),retval); //insert into dictionary
//  		debug("NMGlobalFolders::findParent - generated menu %s",aVirtual.left(sep).data());
  	} else {
//  		debug("NMGlobalFolders::findParent - found %p",retval);
  	}
  	aVirtual = aVirtual.right(aVirtual.length() - sep - 1);
  }
	return retval;	
}

void NMGlobalFolders::initPreMenuBar(KTMainWindow *where)
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry file_menu
  QPopupMenu *file_menu = new QPopupMenu();

  file_menu->insertItem(Icon("filenew.xpm"), i18n("&New Message"), ID_FILE_COMPOSE );
  file_menu->insertSeparator();
  file_menu->insertItem(i18n("P&references"), ID_FILE_PREFERENCES );
  file_menu->insertItem(Icon("openbook.xpm"), i18n("&Addressbook"), ID_FILE_ADDRESSBOOK );
  file_menu->insertItem(i18n("&Send queued Messages"), ID_FILE_SENDQUEUED );
  file_menu->insertSeparator();
  file_menu->insertItem(i18n("&Close"), ID_FILE_CLOSE );
	
  where->menuBar()->insertItem(i18n("&File"), file_menu);

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages

  QObject::connect(file_menu,SIGNAL(activated(int)),kimap,SLOT(commandCallback(int)));
  QObject::connect(file_menu,SIGNAL(highlighted(int)),kimap,SLOT(statusCallback(int)));
}

void NMGlobalFolders::initPostMenuBar(KTMainWindow *where)
{
  ///////////////////////////////////////////////////////////////////
  // menuBar entry help_menu
  QString aboutstring=kapp->appName()+" "+VERSION+"\n\n";

  QPopupMenu *help_menu = kapp->getHelpMenu(true, aboutstring );
  where->menuBar()->insertItem(i18n("&Help"), help_menu);
}

const QString &NMGlobalFolders::getMovePath(int id)
{	
	return getMovePath(gFolders->getAt(id));
}

const QString &NMGlobalFolders::getMovePath(const char *aFolder)
{	
	realFolder *theFolder = findFolder(aFolder);
	if(!theFolder) theFolder = findVirtual(aFolder);
	return getMovePath(theFolder);
}

const QString &NMGlobalFolders::getMovePath(realFolder *selected)
{
	static QString fileName;
	
	if(!selected)
	{
	  fileName = KFileDialog::getSaveFileName(QDir::currentDirPath(), "*", NULL);
		if(!fileName.isEmpty())
		{
			if(QFile::exists(fileName))
			{
				QString str;
	      str.sprintf(i18n( "File %s exists."),fileName.data());
				
	      int rc = QMessageBox::information(NULL, i18n("Information"),
		   	str, i18n("&Append"), i18n("&Overwrite"), i18n("&Cancel"), 0, 2);
      	debug("QMessageBox::result %d",rc);
      	switch(rc)
      	{
      		case 1:
					{      		
      			QFile file(fileName);
      		  if (file.open(IO_Raw|IO_WriteOnly|IO_Truncate))
					  {
						  file.writeBlock("", 0);
						} else {
							debug("Error opening %s for writing!",fileName.data());
						}
					}
      		case 0:
      			break;
					default:
						fileName = "";
						break;
				}
			} else {
				{      		
     			QFile file(fileName);
     		  if (file.open(IO_Raw|IO_WriteOnly))
				  {
					  file.writeBlock("", 0);
					} else {
						debug("Error opening %s for writing!",fileName.data());
					}
				}
			}
		} else {
			fileName = "";
		}
	} else {
		fileName = selected->assembleUWIFolder();
	}
	return fileName;
}

realFolder *NMGlobalFolders::findUnseenFolder(realFolder *startWith)
{
	realFolder *work = NULL;
	
		if(startWith)
		{
			mFolders.findRef(startWith);
			mFolders.next();
		} else
			mFolders.first();
		
		while((work = mFolders.current()))
		{
			if(work->getUnseen() != 0 && work->getCheck()) break;
			work = NULL;
			mFolders.next();
		}
	
	return work;
}

void NMGlobalFolders::moveToUnseenFolder()
{
	realFolder *temp=NULL;
	bool done=false;	
	while(!done && (temp = findUnseenFolder(temp)))
	{
				QString str;
	      str.sprintf(i18n( "Move to next unseen Message in %s ?"),temp->getVirtual().data());
				
	      int rc = QMessageBox::information(NULL, i18n("Information"),
		   	str, i18n("&OK"), i18n("&Next"), i18n("&Cancel"), 0, 0);
      	switch(rc)
      	{
      		case 0:
					{      		
						slotFolder(temp);
						emit signalCurrentFolder(mFolders.findRef(temp));
	
          	QObject::connect( this,	SIGNAL( signalMessageNextUnread() ),
          										temp->getView(), SLOT( slotMessageNextUnread() ) );
	
						emit signalMessageNextUnread();
          	
          	QObject::disconnect( this,	SIGNAL( signalMessageNextUnread() ),
          										temp->getView(), SLOT( slotMessageNextUnread() ) );
						done = true;
						break;
					}
      		case 1:
      			break;
      		case 2:
      			done = true;
      			break;
				}
	}
}

realFolder *NMGlobalFolders::findRecentFolder(realFolder *startWith)
{
	realFolder *work = NULL;
	
	if(startWith)
	{
		mFolders.findRef(startWith);
		mFolders.next();
	} else
		mFolders.first();
		
		while((work = mFolders.current()))
		{
			if(work->getRecent() != 0 && work->getCheck()) break;
			work = NULL;
			mFolders.next();
		}
	
	return work;
}

void NMGlobalFolders::moveToRecentFolder()
{
	realFolder *temp=NULL;
	bool done=false;	
	while(!done && (temp = findRecentFolder(temp)))
	{
				QString str;
	      str.sprintf(i18n( "Move to next recent Message in %s ?"),temp->getVirtual().data());
				
	      int rc = QMessageBox::information(NULL, i18n("Information"),
		   	str, i18n("&OK"), i18n("&Next"), i18n("&Cancel"), 0, 0);
      	switch(rc)
      	{
      		case 0:
					{      		
						slotFolder(temp);
						emit signalCurrentFolder(mFolders.findRef(temp));
						done = true;
						break;
					}
      		case 1:
      			break;
      		case 2:
      			done = true;
      			break;
				}
	}
}

void NMGlobalFolders::checkForQueuedMessages()
{
  	NMClient my_stream;
		KMIdentity myIdentity;
  KConfig *config = kapp->getConfig();

  config->setGroup("General");
  QString mTimeformat = config->readEntry("local-date-format","%c %z");
	bool mLocalizeTime = config->readBoolEntry("localize-time", false);
  	
    debug("Doing Status Lookup on queue folders.");
  	kbp->busy();
		
		myIdentity.toFirst(); 		
 		my_stream.progressNotify(mpSTART,0,i18n("Checking queue Folders"));
  	
  	do {
 				debug("Processing %s",myIdentity.fullName().data());
  			
  			QString saveSend = myIdentity.saveSend();
  			if(!saveSend.isEmpty()) {
  				realFolder *checkThis = findFolder(saveSend);
  				debug("Checking for Queued Msgs in : %s",saveSend.data());
  				
  				my_stream.setBox(checkThis->assembleUWIFolder());
  				if(my_stream.isOpen() && !my_stream.getReadWrite())
  				{
	  				my_stream.searchSimple("UNANSWERED");
	  				QString messages = my_stream.searchResult();
	  				int i,j;
	  				i=-1;j=0;
	  				while((j = messages.find(" ",++i)) && i<j)
	  				{
							bool sentOk = true;
							unsigned long msgId = atol(messages.mid(i,j).data());
							mailMessage *mMsg = my_stream.fetchStructure(msgId);
							mMsg->fullFetch(&my_stream,msgId);
          		{
    	  				QString str,from,to,date,subject;
    	  				kbp->idle();
 								from = decodeMIME2(mMsg->messageFrom(mailEnvelope::textPlain));
 								to = decodeMIME2(mMsg->messageTo(mailEnvelope::textPlain));
 								date = i18ndate(mMsg->dateStr(mTimeformat,mLocalizeTime));
 								subject = decodeMIME2(mMsg->messageSubject());
 								if(from.length() >= 80) from.truncate(80);
 								if(to.length() >= 80) to.truncate(80);
 								if(date.length() >= 80) date.truncate(80);
 								if(subject.length() >= 80) subject.truncate(80);
    	  				str.sprintf(i18n("From: %s\nTo: %s\nDate: %s\nSubject: %s"),from.data(),to.data(),date.data(),subject.data() );
    	  				int rc = QMessageBox::information(NULL, i18n("Send this"),
    	  				str, i18n("Send &now"), i18n("Send &later"), i18n("&Forget it"), 0,1);
    	  				kbp->busy();
    	  				switch(rc) {
    	  					case 0:
    	  									sentOk = true;
    	  									break;
    	  					case 1:
    	  									sentOk = false;
    	  									break;
    	  					case 2:
    	  									sentOk = false;
				  	  						my_stream.flagMsg(msgId,"\\ANSWERED");
    	  									break;
    	  							
    	  				}
          		}
							
          		if(sentOk)
          		{
          			if(myIdentity.method() == KMIdentity::smSMTP)
          			{
          				char *hostlist[] = { (myIdentity.smtpHost()).data(),NULL };
          				if(!my_stream.sendMessage(mMsg,hostlist,identity->smtpPort() )) sentOk = false;
          			} else {
          				QString mailer = myIdentity.mailer() + " -bs";
          				char *hostlist[] = { mailer.data(),NULL };
          				if(!my_stream.sendMessage(mMsg,hostlist,-1)) sentOk = false;
          			}
  	  					if(sentOk) {
  	  						my_stream.flagMsg(msgId,"\\ANSWERED");
  	  					}
  	  				}
	  					
	  					i = j; //find next one
	  				}
	  			} else {
	  				QString str;
	  				kbp->idle();
	  				str.sprintf(i18n("Couldn't open\n%s\nfor Read/Write access!"),checkThis->assembleURIFolder());
	  				QMessageBox::information(NULL, i18n("Information"),
	  				str, i18n("&OK"), 0, 0);
	  				kbp->busy();
	  			}
  				my_stream.closeBox();
 			}
  	} while(myIdentity.setNext());
 		my_stream.progressNotify(mpSTOP,0,i18n("Checking queue Folders"));
		kbp->idle();  	
}
