/***************************************************************************
                          nmlistfolders.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef NMLISTFOLDERS_H
#define NMLISTFOLDERS_H

#include <qwidget.h>
#include <qlistview.h>
#include <qpixmap.h>

class QPopupMenu;
/**
  *@author Sven Carstens
  */

//class QDialog;
class KConfig;
class realFolder;

class NMListFolders : public QListView  {
   Q_OBJECT
public: 
	NMListFolders(QWidget *parent=0, const char *name=0);
	~NMListFolders();

	void readFolders();
	const char *fullPath(QListViewItem *);

public slots:
	void statusCallback(int);
	void commandCallback(int);
	
	QListViewItem *insertFolder(const char *,const char *);
	void slotFStatus();
	void slotFNew();
	void slotFDelete();
	void slotFProperties();
	void slotFExpunge();
	void slotFOpenNew();
	void slotFRename();
	void slotRightButtonClicked(QListViewItem *,const QPoint &,int);
	QListViewItem *findItem(QListViewItem *,int,const char *);
	void resize(void);
	void slotDoubleClicked(QListViewItem *);

	void scrollDown();
	void scrollUp();
	void expand();
	void collapse();

	void slotStatus(const char *,int,int,int,int);
	void slotChanged(int,realFolder *);
	void setCurrentFolder(int);		

signals:
	void signalExpunge(int);
	void signalFolder(const char *);
	void signalNFolder(const char *);
	
protected:
	void resizeEvent(QResizeEvent *);
	void resizeContents(int,int);

private:
	void initMenu();
	void setCurrentFolder(QListViewItem *);		
  QListViewItem *findParent(QString dir,QListViewItem *item);
	QListViewItem *currentPopup;
	QListViewItem *currentFolder;
	QPixmap	pixmapSSL;
};

#endif
