/***************************************************************************
                          nmsearch.h  -  description
                             -------------------
    begin                : Mon Mar 20 2000
    copyright            : (C) 2000 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qtabdialog.h>
#include <qstring.h>
#include <qcheckbox.h>

class QGridLayout;
class QBoxLayout;
class KTabListBox;
class QLineEdit;
class QButtonGroup;
class QRadioButton;
class QPushButton;
class QComboBox;
class QFileDialog;
class QLabel;

class NMSearch : public QTabDialog
{
  Q_OBJECT
public:
  NMSearch(QWidget *parent=0,const char *name=0);
  ~NMSearch();

  	enum eActions {
		doNOOP, doFlag,doUnFlag,doToggleFlag,doDelete, doMoveFolder,doMoveFile
	};

  const char *getSearchString();
  const char *getActionPath();
  enum eActions getAction();

protected:
  virtual void createTabSearch(QWidget*);

  // Create a button in given grid. The name is internationalized.
  virtual QPushButton* createPushButton(QWidget* parent, QGridLayout* grid,
					const char* label, 
					int row, int col);

protected slots:
  void doApply();
  void doCancel();

private:
  QLineEdit *searchEdit;
  QRadioButton *flagRadio, *unflagRadio, *toggleflagRadio;
  QRadioButton *moveFileRadio, *moveFolderRadio, *deleteRadio;
  QPushButton *addButton,*modifyButton,*removeButton;
};
