/***************************************************************************
                          nmselect.h  -  description
                             -------------------
    begin                : Tue Oct 26 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef NMSELECT_H
#define NMSELECT_H

#include <qwidget.h>
#include <qdialog.h>
#include "ktmainwindow.h"
class NMListRemote;
class QPushButton;
class QButtonGroup;
class QGroupBox;
class QLineEdit;
class QListViewItem;
class QStrList;
class QPoint;
class QCheckBox;

/**
  *@author Sven Carstens
  */

class NMSelect : public KTMainWindow  {
   Q_OBJECT
public: 
	NMSelect(QWidget *parent=0, const char *name=0);
	~NMSelect();

	void openFirst(void);
	bool validFirst(void);
	void closeFirst(void);

	void openSecond(void);
	bool validSecond(void);
	void closeSecond(void);

	void openThird(void);
//	bool validThird(void);
	void closeThird(void);

	QStrList *getSelected(void);
	void done(int);
	int result();
	
public slots:
	void slotOkPressed(void);
	void slotPrevPressed(void);
	void slotNextPressed(void);
	void slotCancelPressed(void);
	void slotDoubleClicked(QListViewItem *);
	void slotRightButtonClicked(QListViewItem *,const QPoint &,int);

protected:
	void selectAll(QListViewItem *);
	QButtonGroup *first;
	QGroupBox *second;
	NMListRemote *third;

	QPushButton *ok;
	QPushButton *cancel;
	QPushButton *next;
	QPushButton *prev;


	void resizeEvent(QResizeEvent *);
	int in_protocol;
	QString protocol;
	QString host;
	QLineEdit *in_host;
	QString port;
	QLineEdit *in_port;
	QString user;
	QLineEdit *in_user;
	QString pattern;
	QLineEdit *in_pattern;
	bool useSSL;
	QCheckBox *in_useSSL;

private:
	void iterateList(QListViewItem *,QStrList *);
	int my_result;
	class NMStatusBar *mStatusBar;
};

#endif
