/***************************************************************************
                          nmstatusbar.h  -  description
                             -------------------
    begin                : Wed May 24 2000
    copyright            : (C) 2000 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NMSTATUSBAR_H
#define NMSTATUSBAR_H

#include <qwidget.h>
#include <kstatusbar.h>
#include <qstack.h>
#include <sys/time.h>
#include "nmclient.h"
/**
  *@author Sven Carstens
  */

struct progressObject {
	const char *pName;
	time_t pStart;
	long pTotal,pCurrent;
};

class NMStatusBar : public KStatusBar  {
   Q_OBJECT
public: 
	NMStatusBar(QWidget *parent=0, const char *name=0);
	~NMStatusBar();
	static bool connectToStatusBar(QObject *,QWidget *);
	static bool disconnectStatusBar(QObject *,QWidget *);

public slots:
	void progressNotify(enum mailProgress, unsigned long, const char *,bool &);
	void cancelWasPressed();
  void slotStatusMsg(const char *text);
  void slotStatusHelpMsg(const char *text);
		
private:
	class QPushButton *mCancelButton;
	class QProgressBar *mProgress;
	class QStack<struct progressObject> mStack;
	char mBuffer[128];
	bool cancelPressed;
};

#endif
