/***************************************************************************
                          qpasswdfile.h  -  description
                             -------------------
    begin                : Sat Dec 25 1999
    copyright            : (C) 1999 by Sven Carstens
    email                : s.carstens@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPASSWDFILE_H
#define QPASSWDFILE_H

#include <qwidget.h>
#include <qfile.h>

/**
  *@author Sven Carstens
  */

class QPasswdFile : public QFile  {
public:
	QPasswdFile(const char *,const char *);
	~QPasswdFile();
	virtual bool at( int );
	virtual bool open( int );
	virtual int readLine(char *,unsigned int);
	virtual int getch();
	virtual bool atEnd() const;
	virtual void close();
	virtual int writeBlock(const char *,unsigned int);
	virtual int putch(int);

protected:
	QString decoded_buffer;
	unsigned long decoded_at;
	bool dirty_buffer;
	QString encoder;
};

#endif
